package com.cool.hot100.common_arr;

import org.junit.Test;

public class Num53 {

    /**
     * 53. 最大子序和
     */
    /**
     * 给你一个整数数组 nums ，请你找出一个具有最大和的连续子数组（子数组最少包含一个元素），返回其最大和。
     * 子数组
     * 是数组中的一个连续部分。
     * 示例 1：
     * 输入：nums = [-2,1,-3,4,-1,2,1,-5,4]
     * 输出：6
     * 解释：连续子数组 [4,-1,2,1] 的和最大，为 6 。
     * 示例 2：
     * 输入：nums = [1]
     * 输出：1
     * 示例 3：
     * 输入：nums = [5,4,-1,7,8]
     * 输出：23
     *
     * @param nums
     * @return
     */

    public int maxSubArray(int[] nums) {
        int left = 0;
        int right = 0;
        int res = Integer.MIN_VALUE;
        int sum = 0;
        while (right < nums.length) {
            sum += nums[right++];
            if (sum >= 0) {
            } else {
                sum = 0;
            }
            res = Math.max(sum, res);
        }
        return res;
    }

    @Test
    public void test() {
        System.out.println(maxSubArray(new int[]{-2, 1, -3, 4, -1, 2, 1, -5, 4}));
    }


}
